/*
   Written by Pieter J. Schoenmakers <tiggr@ics.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: nextstep4.c,v 1.6 2000/05/11 20:16:12 tiggr Exp $  */

#include <mach-o/rld.h>

/********** dynamic loading **********/

void
dload_initialize ()
{
}

void *
dload_load (char *name)
{
  NXStream *str = NXOpenFile (2, NX_WRITEONLY);
  const char * const names[2] = {name, 0};
  int r = rld_load (str, 0, names, 0);

  NXClose (str);
  return r ? name : 0;
}

void *
dload_lookup (void *handle, char *name)
{
  unsigned long value;
  NXStream *str = NXOpenFile (2, NX_WRITEONLY);
  int r = rld_lookup (str, name, &value);

  /* Be prepared for a port to the alpha.  */
  if (sizeof (value) < sizeof (void *))
    abort ();

  NXClose (str);
  return r ? (void *) value : 0;
}

void
dload_symbol_info (void *address,
		   i_tom_ByteString *file_name,
		   void **base_address,
		   i_tom_ByteString *symbol_name,
		   void **symbol_address,
		   void **offset)
{
  *file_name = *base_address = *symbol_name = *symbol_address = *offset = 0;
}
