<copyright> TOO DescriptorDelegate.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright (C) 1996 Pieter J. Schoenmakers.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: DescriptorDelegate.t,v 1.4 2000/06/29 21:10:44 tiggr Exp $</id>
    </copyright>

/******************** DescriptorDelegate ********************/

<doc> DescriptorDelegate classes are used to define the logic for handling
    read and write events on file {Descriptor}s.  Users should create
    new classes inheriting from either {DescriptorReadDelegate} or
    {DescriptorWriteDelegate}, providing an implementation of either
    {readEventOnDescriptor} or {writeEventOnDescriptor} respectively,
    to implement their application logic.  </doc>
implementation class DescriptorDelegate end;

implementation instance
DescriptorDelegate

end;

/******************** DescriptorReadDelegate ********************/

implementation class
DescriptorReadDelegate: DescriptorDelegate

end;

implementation instance
DescriptorReadDelegate

<doc> The {RunLoop} has determined that the {Descriptor} {d} is
    readable.  </doc>
deferred void
  readEventOnDescriptor Descriptor d;

end;

/******************** DescriptorWriteDelegate ********************/

implementation class
DescriptorWriteDelegate: DescriptorDelegate

end;

implementation instance
DescriptorWriteDelegate

<doc> The {RunLoop} has determined that the {Descriptor} {d} is
    writable.  </doc>
deferred void
  writeEventOnDescriptor Descriptor d;

end;
